#!/bin/tcsh -f

set fls = (k5vsi-vdif-dim k5vsi-vssp-dim sudp_send  \
    vsi_localwrite_srv vsi_sudptx_srv InVSI-test InVSI-bist )

foreach f ($fls)
    if( !( -e $f) ) continue 
    ls -l $f
    chown root $f
    chmod g+w $f
    chmod +s $f
    ls -l $f
end

set vdir = `cd ..; pwd`
set bdir = "${vdir}/bin"
echo "bdir = ${bdir}"

foreach f ($fls)
    set f1 = ${bdir}/${f}
    if( !( -e ${f1}) ) continue 
    ls -l ${f1}
    chown root ${f1}
    chmod g+w ${f1}
    chmod +s ${f1}
    ls -l ${f1}
end

set fls = (InVSI-test conf-test InVSI-bist)
set dpath = "${vdir}/test"
foreach f ($fls)
    set f1 = ${dpath}/${f}
    ls -l ${f1}
    chown root ${f1}
    chmod g+w ${f1}
    chmod +s ${f1}
    ls -l ${f1}
end


