/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (Wed, 03 Jul 2013) $
 * $Id: VDIF_Header.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include "VDIF_Header.hpp"

//======= VDIF libraries ==== from here ======

// int32_t  VDIFHd_find(const uint8_t* buf, const uint32_t nbyte){
//   uint32_t remain = nbyte;
//   int find_flag=0; 
//   uint8_t *pb = (uint8_t* )buf;
//   uint32_t hdsize = Headsize();
//   int32_t count=0;
//   VDIF_Header* phead;
  
//   while( remain >= hdsize && find_flag==0){
//     phead = (VDIF_Header *)pb;
//     if( phead->exud_nict.ext_dat_ver == 1
// 	&& phead->HD_Match()exud_nict.sync == VDIF_NICT_SYNC ){
//       find_flag =1;
//       memcpy(&head_buf[0], pt_head, Headsize());
//       return(count);
//     }else{
//       pb++; count++; remain--;
//     }
//   } // end while 

//   return(-1);
// }

//time_t VDIF_Hdr::Ref_Epoch()const {
Time_dat VDIF_Hdr::Ref_Epoch()const {
  int iy = Ref_Epoch_hy_counter/2;
  int im = Ref_Epoch_hy_counter % 2;
  int mon = im ? 7 : 1;
  int year = iy +2000;
//   struct tm tm1;
//   memset(&tm1,0,sizeof(tm1));
//   tm1.tm_year = year;
//   tm1.tm_mon = mon;
//   tm1.tm_mday = 1;
//   time_t ret = mktime(&tm1);
//   return ret;

  Time_dat t1(year,mon,1,0,0,0);
  return t1;
//   switch(Ref_Epoch_hy_counter){
//   case 0:  t1.Set_time(2000,1,1,0,0,0);break;
//   case 1:  t1.Set_time(2000,7,1,0,0,0);break;
//   case 2:  t1.Set_time(2001,1,1,0,0,0);break;
//   case 3:  t1.Set_time(2001,7,1,0,0,0);break;
//   case 4:  t1.Set_time(2002,1,1,0,0,0);break;
//   case 5:  t1.Set_time(2002,7,1,0,0,0);break;
//   case 6:  t1.Set_time(2003,1,1,0,0,0);break;
//   case 7:  t1.Set_time(2003,7,1,0,0,0);break;
//   case 8:  t1.Set_time(2004,1,1,0,0,0);break;
//   case 9:  t1.Set_time(2004,7,1,0,0,0);break;
//   case 10:  t1.Set_time(2005,1,1,0,0,0);break;
//   case 11:  t1.Set_time(2005,7,1,0,0,0);break;
//   case 12:  t1.Set_time(2006,1,1,0,0,0);break;
//   case 13:  t1.Set_time(2006,7,1,0,0,0);break;
//   case 14:  t1.Set_time(2007,1,1,0,0,0);break;
//   case 15:  t1.Set_time(2007,7,1,0,0,0);break;
//   case 16:  t1.Set_time(2008,1,1,0,0,0);break;
//   case 17:  t1.Set_time(2008,7,1,0,0,0);break;
//   case 18:  t1.Set_time(2009,1,1,0,0,0);break;
//   case 19:  t1.Set_time(2009,7,1,0,0,0);break;
//   case 20:  t1.Set_time(2011,1,1,0,0,0);break;
//   case 21:  t1.Set_time(2011,7,1,0,0,0);break;
//   case 22:  t1.Set_time(2012,1,1,0,0,0);break;
//   case 23:  t1.Set_time(2012,7,1,0,0,0);break;
//   case 24:  t1.Set_time(2013,1,1,0,0,0);break;
//   case 25:  t1.Set_time(2013,7,1,0,0,0);break;
//   case 26:  t1.Set_time(2014,1,1,0,0,0);break;
//   case 27:  t1.Set_time(2014,7,1,0,0,0);break;
//   case 28:  t1.Set_time(2015,1,1,0,0,0);break;
//   case 29:  t1.Set_time(2015,7,1,0,0,0);break;
//   }
//   return t1;
}


/// Since Frame_Length have to be selected under the conditions:
///   -- Total data amount in a second have to be transfered by exact Integer number of packets.
///   -- Frame_Length must be expressed by 8Bytes units, 
int VDIF_Hdr::Set_Sparam(const int nch, const int qbit, const uint32_t srate){
  Set_Qbit(qbit);
  Set_Nch(nch);
  Set_Srate(srate);
//   int32_t tsize = srate/8*nch*qbit; // Total Bytes/sec
//   int ps = 1500 - 32;
//   for(; ps>0; ps--){ if(tsize % ps == 0 && ps % 8 ==0) break; }
//   if(ps==0){
//     cerr << "Error in VDIF_Hdr::Set_Sparam(): Could not find appropriate packet size\n";
//     return -1;
//   }
  //  Frame_Length = (ps+32)/8 -1 ;
  return 0;
}

Time_dat VDIF_Hdr::Set_Epoch0(const time_t t1){

  time_t t2 = t1;
  struct tm tm1;
  //  , tm2;
  gmtime_r(&t2, &tm1);
//   memset(&tm2,0,sizeof(tm2));
//   tm2.tm_year = tm1.tm_year;
//   tm2.tm_mon = (tm1.tm_mon >= 6 ) ? 6 : 0;
//   tm2.tm_mday = 1;
  int year = tm1.tm_year + 1900;
  int mon = tm1.tm_mon + 1;
   
  //  time_t t0 = mktime(&tm2);
  Time_dat t0(year,mon,1,0,0,0);

  int dy  =tm1.tm_year - 100;
  int cnt = dy * 2;
  cnt += (tm1.tm_mon >= 6 ) ? 1 : 0;
  Ref_Epoch_hy_counter = cnt;
//   Time_dat t2(t1);
//   HY_Time h1 = t2.HY_Time(); 
//   Ref_Epoch_hy_counter = h1.Hyear_cnt();
  return t0;
}
// void VDIF_Hdr::Set_Epoch(const time_t t1, const time_t t0_ref){
//   Sec_from_Ref = t1 - t0_ref;
// }


void VDIF_Hdr::Set_Epoch(const Time_dat &t1){
  HY_Time h1 = t1.Hy_time();
  //  time_t t_work = t1.Time_t();

  //  double soy0 = Set_Epoch0(t_work).Soy();;
  //  double soy = t1.Soy();
  //  Sec_from_Ref =  soy - soy0;
  if( Ref_Epoch_hy_counter==0)
    Ref_Epoch_hy_counter = h1.Hyear_cnt();
  
  Sec_from_Ref = (int)(t1 - Ref_Epoch());
}


// void VDIF_Hdr::Print_hd(FILE *fp, const int fmt){
//   int v1 =Version_No, v2=exud_nict.ext_dat_ver;
//   switch(fmt){
//   case 20:
//     // Print only constant
//     fprintf(fp, "VDIFHD(%s) Stn:%s:%s ThredID=%d Type:%s\n",
// 	    Version().c_str(), Stname().c_str(), Stnid().c_str(),
// 	    Thread_Id, Dtype().c_str()); 
    
//     break;
//   case 21:
//     { // Print variable part by frames
//       if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
// 	double dt = (double)(Framesize() - Headsize())*8./Qbit()/Nch()/Srate();
// 	Time_dat t1 = Epoch() + dt * iFrame();
// 	fprintf(fp,"ifrm=%8d Epoch=%s FrmLen=%8d", 
// 		iFrame(),t1.Print_time(20).c_str(), Framesize());
//       }else{
// 	fprintf(fp,"ifrm=%8d Epoch=%s FrmLen=%8d", 
// 		iFrame(),Epoch().Print_time(21).c_str(), Framesize());
//       }
//       if(Invalid_flag){  fprintf(fp," Invalid:");}
//       else{              fprintf(fp," Valid  :");  }
//       fprintf(fp," Ref=%s", Ref_Epoch().Print_time(21).c_str());      
//       if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
// 	if(Srate() < 1000000)
// 	  fprintf(fp," %3dksps/%dbit/%dch ",  Srate()/1000,Qbit(), Nch());
// 	else
// 	  fprintf(fp," %3dMsps/%dbit/%dch ",  Srate()/1000000,Qbit(), Nch());
//       }else{
// 	fprintf(fp," %dbit/%dch ",  Qbit(), Nch());
//       }
//       putc('\n',fp);
//     }
//     break;
//   case 22:
//     { // Print variable part by frames without CR
//       string ep = Epoch().Print_time(20);
//       fprintf(fp,"ifrm=%8d Epoch=%s FrmLen=%8d", 
// 	      iFrame(), ep.c_str(), Framesize());
      
//       if(Invalid_flag){  fprintf(fp," Invalid:");}
//       else{              fprintf(fp," Valid  :");  }
//       string ep0 = Ref_Epoch().Print_time(21);
//       fprintf(fp," Ref=%s", ep0.c_str());      
//       if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
// 	if(Srate() < 1000000)
// 	  fprintf(fp," %3dksps/%dbit/%dch ",  Srate()/1000,Qbit(), Nch());
// 	else
// 	  fprintf(fp," %3dMsps/%dbit/%dch ",  Srate()/1000000,Qbit(), Nch());
//       }else{
// 	fprintf(fp," %dbit/%dch ",  Qbit(), Nch());
//       }
//     }
//     break;
//   case 2: // Print everything in one line
//     fprintf(fp," %5ld ",(long)iFrame());
//     fprintf(fp,"%s %d ", Epoch().Print_time(10).c_str(), ThreadID());
//     fprintf(fp,"%8s:%2s ", Stname().c_str(),Stnid().c_str());
//     fprintf(fp,"%3d %1d %2d %d ", Srate()/1000000, Qbit(),Nch(),
// 	    Framesize());
//     fprintf(fp," %s %s %s\n", Version().c_str(), Dtype().c_str(),
// 	    Ref_Epoch().Print_time(21).c_str());
//     //    fflush(fp);
//     break;
//   case 1:
//   default:{
//     fprintf(fp, "-VDIFHD (Ver. %d.%d):", v1,v2);

//     if(Invalid_flag){  fprintf(fp," Invalid:");}
//     else{              fprintf(fp," Valid  :");  }

//     string ep0 = Ref_Epoch().Print_time(21);
//     string ep = Epoch().Print_time(20);
//     fprintf(fp," Ref=%s Epoch=%s", 
// 	    //	  Str_Ref_Epoch().c_str(),
// 	    ep0.c_str(),ep.c_str());
//     int fn = Frame_Number, fl = (Frame_Length+1)*8;
//     fprintf(fp, " ifrm=%6d FrmLen=%6d Byte", fn,fl);
//     string dat_type = Complex_data_flag ? "Cmplx" : "Real";
//     fprintf(fp," SID:%c%c Thrd=%d Type:%s",
// 	    Station_ID[0], Station_ID[1], 
// 	    Thread_Id, dat_type.c_str()); 
//     if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
//       if(Srate() < 1000000)
// 	fprintf(fp," %3dksps/%dbit/%dch ",  Srate()/1000,Qbit(), Nch());
//       else
// 	fprintf(fp," %3dMsps/%dbit/%dch ",  Srate()/1000000,Qbit(), Nch());
//       string stname;
//       exud_nict.Get_Stname(stname);
//       fprintf(fp," Stn:%s ",stname.c_str());
//     }
//     putc('\n',fp);
//   }
//     break;
//   }
    
//   //  fprintf(fp,"----------------------------\n");
  
// }


string VDIF_Hdr::Str_hd(const int fmt){
  int v1 =Version_No, v2=exud_nict.ext_dat_ver;
  char strbuf[256]; string retstr;

  switch(fmt){
  case 20:
    // Print only constant
    sprintf(strbuf, "VDIFHD(%s),Stn:%s:%s,ThredID=%d,Type:%s,Ref:%s,FrmLen=%d ",
	    Version().c_str(), Stname().c_str(), Stnid().c_str(),
	    Thread_Id, Dtype().c_str(), Ref_Epoch().Print_time(21).c_str(),
	    Framesize()); 
    retstr = strbuf;
    if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
      if(Srate() < 1000000)
	sprintf(strbuf,"Mode:%dksps/%dbit/%dch ",  Srate()/1000,Qbit(), Nch());
      else
	sprintf(strbuf,"Mode:%dMsps/%dbit/%dch ",  Srate()/1000000,Qbit(), Nch());
    }else{
      sprintf(strbuf,"Mode:%dbit/%dch ",  Qbit(), Nch());
    }
    retstr += strbuf;
    break;
  case 21:
    { // Print variable part by frames
      if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
	double dt = (double)(Framesize() - Headsize())*8./Qbit()/Nch()/Srate();
	Time_dat t1 = Epoch() + dt * iFrame();
	sprintf(strbuf,"ifrm=%2d Epoch=%s", 
		iFrame(),t1.Print_time(20).c_str());
	retstr = strbuf;
      }else{
	sprintf(strbuf,"ifrm=%2d Epoch=%s", 
		iFrame(),Epoch().Print_time(21).c_str());
	retstr = strbuf;
      }
      if(Invalid_flag){  sprintf(strbuf," Invalid:");}
      else{              sprintf(strbuf," Valid  :");  }
      retstr += strbuf;
//       sprintf(strbuf," Ref=%s", Ref_Epoch().Print_time(21).c_str());      
//       retstr += strbuf;
      
    }
    break;
  case 22:
    { // Print variable part by frames without CR
      string ep = Epoch().Print_time(20);
      sprintf(strbuf,"ifrm=%5d Epoch=%s FrmLen=%6d", 
	      iFrame(), ep.c_str(), Framesize());
      retstr = strbuf;
      if(Invalid_flag){  sprintf(strbuf," Invalid:");}
      else{              sprintf(strbuf," Valid  :");  }
      retstr += strbuf;

//       string ep0 = Ref_Epoch().Print_time(21);
//       fprintf(fp," Ref=%s", ep0.c_str());      
      if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
	if(Srate() < 1000000)
	  sprintf(strbuf," %3dksps/%dbit/%dch ",Srate()/1000,Qbit(), Nch());
	else
	  sprintf(strbuf," %3dMsps/%dbit/%dch ",Srate()/1000000,Qbit(), Nch());
      }else{
	sprintf(strbuf," %dbit/%dch ", Qbit(), Nch());
      }
      retstr += strbuf;
    }
    break;
  case 2: // Print everything in one line
    sprintf(strbuf," %5ld %s %d %8s:%2s %3d %1d %2d %d %s %s %s",
	    (long)iFrame(), Epoch().Print_time(10).c_str(), 
	    ThreadID(), Stname().c_str(),Stnid().c_str(),
	    Srate()/1000000, Qbit(),Nch(), Framesize(),
	    Version().c_str(), Dtype().c_str(),
	    Ref_Epoch().Print_time(21).c_str());
    retstr = strbuf;
    break;
  case 1:
  default:{
    sprintf(strbuf, "-VDIFHD (Ver. %d.%d):", v1,v2);
    retstr = strbuf;
    if(Invalid_flag){  sprintf(strbuf," Invalid:");}
    else{              sprintf(strbuf," Valid  :");  }
    retstr += strbuf;
   
    string ep0 = Ref_Epoch().Print_time(21);
    string ep = Epoch().Print_time(20);
    sprintf(strbuf," Ref=%s Epoch=%s", ep0.c_str(),ep.c_str());
    retstr += strbuf;

    int fn = Frame_Number, fl = (Frame_Length)*8;
    sprintf(strbuf, " ifrm=%2d FrmLen=%6d Byte", fn,fl);
    retstr += strbuf;

    string dat_type = Complex_data_flag ? "Cmplx" : "Real";
    sprintf(strbuf," SID:%c%c Thrd=%d Type:%s",
	    Station_ID[0], Station_ID[1], 
	    Thread_Id, dat_type.c_str());
    retstr += strbuf;
    
    if(exud_nict.ext_dat_ver == 1){ // NICT's extended user data
      if(Srate() < 1000000)
	sprintf(strbuf," %3dksps/%dbit/%dch ",  Srate()/1000,Qbit(), Nch());
      else
	sprintf(strbuf," %3dMsps/%dbit/%dch ",  Srate()/1000000,Qbit(), Nch());
      retstr += strbuf;

      string stname;
      exud_nict.Get_Stname(stname);
      sprintf(strbuf," Stn:%s ",stname.c_str());
      retstr += strbuf;
    }
  }
    break;
  }
  
  return retstr;
}


const bool VDIF_Hdr_find(const uint8_t*  buf, const uint32_t nbyte, 
			 long& offset, VDIF_Hdr *vdif_hdr){
  uint32_t remain = nbyte;
  uint8_t *pb = (uint8_t* )buf;

  VDIF_Hdr *pt_head(0); 
  uint32_t hdsize = pt_head->Headsize();
  int32_t count=0;

  while( remain >= hdsize ){
    pt_head = (VDIF_Hdr*)pb;
    if(pt_head->exud_nict.ext_dat_ver == 1){
      if( pt_head->HD_Match() ){
	*vdif_hdr = *pt_head;
	offset =  count;
	return( true);
      }
    }else{// Standard VDIF 
      if(pt_head->Framesize() < 1000 || 
	 pt_head->exud_nict.ext_dat_ver >1){
	// unlikely correct VDIF header.
	count++; remain--; pb++;
      }else{ // May be correct VDIF header 
	*vdif_hdr = *pt_head;
	offset = count;
	return(true);
      }
    } // end for
  } // end while 

  return(false);
}

// Return offset and vdif_head
const bool VDIF_Hdr_find(FILE *fp, long &offset,  VDIF_Hdr *vdif_head){

  VDIF_Hdr*  pt_head(0);
  int32_t count=0;
  int32_t hdsize = pt_head->Headsize();
  int bufsize = hdsize * 10;
  uint8_t buf[bufsize];
  int nerr =0;
  try{
    while( feof(fp) == 0 && nerr < 3){
      int nread = fread(buf,bufsize,1,fp);
      if( nread <1 ){
	throw "VDIF_Hdr_find fread() returns 0";
      }
      pt_head  = (VDIF_Hdr*)buf;
    
      for(int i=0; i<bufsize; i++){
	//    if(dbg_disp_level>10) pt_head->Disp();
	if( pt_head->exud_nict.ext_dat_ver == 1){ // NICT Extension
	  if(pt_head->HD_Match() ){
	    fseek(fp,count-bufsize,SEEK_CUR);
	    *vdif_head = *pt_head;
	    offset = count;
	    return(true);
	  }
	}else{// Standard VDIF 
	  if(pt_head->Framesize() < 1000 || 
	     pt_head->exud_nict.ext_dat_ver >1){
	    // unlikely correct VDIF header.
	    count++; 
	    pt_head = (VDIF_Hdr*)(buf + i);
	  }else{ // May be correct VDIF header 
	    fseek(fp,count-bufsize,SEEK_CUR);
	    *vdif_head = *pt_head;
	    offset = count;
	    return(true);
	  }
	}
      } // End for 
      nerr++;
    } // end while 
  } // end try

  catch(const char *msg){
    cerr << msg << strerror(errno) << endl;
    if(feof(fp)) cerr << "EOF found.\n";
  }

  return (false);

}


/// ifmt=0: yyyy/mon/day-hh:mm:ss
// string VDIF_Hdr::Str_Ref_Epoch(const int ifmt){
  
//   string str;
//   time_t t1 = Ref_Epoch();
//   struct tm tm1;
//   gmtime_r(&t1, &tm1);
//   char buf[80];
//   switch(ifmt){
//   case 0:
//     strftime(buf,80,"%Y/%m/%d-%H:%M:%S", &tm1);
//     str = buf;
//     break;
//   case 1:
//   default:
//     fprintf(stderr,"VDIF_Hdr::Str_Ref_Epoch(): ifmt(%d) is not implemented\n",
// 	    ifmt);
//     break;
//   }

//   return str;
// }
//======= VDIF libraries ==== to   here ======
